
precision mediump float;
varying vec2 v_texcoord;
uniform sampler2D tex_sampler;
uniform int type;
vec4 HmdWarpParam = vec4(1.0, 0.21, 0.163, 0.04);

vec2 HmdWarp(vec2 texIn, vec2 lensCenter)
{
  vec2 theta = (texIn - lensCenter) ;

  float rSq = theta.x * theta.x   + theta.y * theta.y ;
  vec2 theta1 = theta * (HmdWarpParam.x + HmdWarpParam.y * rSq + HmdWarpParam.z * rSq * rSq + HmdWarpParam.w * rSq * rSq * rSq);
  return lensCenter +  theta1;
}

void main() {
  if(type == 0){
    gl_FragColor = texture2D(tex_sampler, v_texcoord);
  }
  else if(type == 1){
    vec2 tc = HmdWarp(v_texcoord.xy, vec2(0.5,0.5));
    vec2 ScreenCenter = vec2(0.5, 0.5);
    if (any(notEqual(clamp(tc, ScreenCenter-vec2(0.5,0.5), ScreenCenter+vec2(0.5, 0.5)) - tc, vec2(0.0, 0.0))))
      gl_FragColor = vec4(0.0, 0.0, 0.0, 1.0);
    else
      gl_FragColor = texture2D(tex_sampler, tc);
  }
  else{
    if(all(lessThan(v_texcoord, vec2(0.5,1)))){
      vec2 tc = HmdWarp(v_texcoord.xy, vec2(0.25,0.5));
      vec2 ScreenCenter = vec2(0.25, 0.5);
      if (any(notEqual(clamp(tc, ScreenCenter-vec2(0.25,0.5), ScreenCenter+vec2(0.25, 0.5)) - tc, vec2(0.0, 0.0))))
        gl_FragColor = vec4(0.0, 0.0, 0.0, 1.0);
      else
        gl_FragColor = texture2D(tex_sampler, tc);
    }
    else{
      gl_FragColor = texture2D(tex_sampler, v_texcoord);
    }
  }
}