#extension GL_OES_EGL_image_external : require
precision mediump float;
varying vec2 vTextureCoord;
uniform samplerExternalOES sTexture;
uniform int type;
vec4 HmdWarpParam = vec4(1.0, 0.21, 0.163, 0.04);

vec2 HmdWarp(vec2 texIn, vec2 lensCenter)
{
  vec2 theta = (texIn - lensCenter) ;

  float rSq = theta.x * theta.x * 4.0   + theta.y * theta.y ;
  vec2 theta1 = theta * (HmdWarpParam.x + HmdWarpParam.y * rSq + HmdWarpParam.z * rSq * rSq + HmdWarpParam.w * rSq * rSq * rSq);
  return lensCenter +  theta1;
}

void main() {
  if(type == 0)
  {
    gl_FragColor = texture2D(sTexture, vTextureCoord);
  }
  else if(type == 1)
  {
    if(all(lessThan(vTextureCoord, vec2(0.495,1))))
    {
      gl_FragColor = texture2D(sTexture, vTextureCoord);
    }
	else if(all(greaterThan(vTextureCoord, vec2(0.505,0))))
    {
      gl_FragColor = texture2D(sTexture, vTextureCoord);
    }
	else
	{
	  gl_FragColor = vec4(0.0);
	}
  }
  else if(type == 2)
  {
    if(all(lessThan(vTextureCoord, vec2(0.5,1))))
    {
      vec2 tc = HmdWarp(vTextureCoord.xy, vec2(0.25,0.5));
      vec2 ScreenCenter = vec2(0.25, 0.5);
      if (any(notEqual(clamp(tc, ScreenCenter-vec2(0.25,0.5), ScreenCenter+vec2(0.25, 0.5)) - tc, vec2(0.0, 0.0))))
        gl_FragColor = vec4(0.0, 0.0, 0.0, 1.0);
      else
      {
        float ybias = tc.y * 2.0 - 0.5;
        if(ybias < 0.0)
          gl_FragColor = vec4(0.0, 0.0, 0.0, 1.0);
        else if(ybias > 1.0)
          gl_FragColor = vec4(0.0, 0.0, 0.0, 1.0);
        else
          gl_FragColor = texture2D(sTexture, vec2(tc.x, ybias));
      }
    }
    else
    {
      vec2 tc = HmdWarp(vTextureCoord.xy, vec2(0.75,0.5));
      vec2 ScreenCenter1 = vec2(0.75, 0.5);
      if (any(notEqual(clamp(tc, ScreenCenter1-vec2(0.25,0.5), ScreenCenter1+vec2(0.25, 0.5)) - tc, vec2(0.0, 0.0))))
        gl_FragColor = vec4(0.0, 0.0, 0.0, 1.0);
      else
      {
        float ybias = tc.y * 2.0 - 0.5;
        if(ybias < 0.0)
          gl_FragColor = vec4(0.0, 0.0, 0.0, 1.0);
        else if(ybias > 1.0)
          gl_FragColor = vec4(0.0, 0.0, 0.0, 1.0);
        else
          gl_FragColor = texture2D(sTexture, vec2(tc.x, ybias));
      }
    }
  }
  else if(type == 3)
  {
    if(vTextureCoord.y > 0.95)
      gl_FragColor = vec4(0.2, 0.2, 0.2, 1.0);
    else if(vTextureCoord.y < 0.05)
      gl_FragColor = vec4(0.2, 0.2, 0.2, 1.0);
    else
      gl_FragColor = vec4(0.0, 0.0,0.0, 1.0);
  }
}